# API Reference <a name="API Reference"></a>

## Constructs <a name="Constructs"></a>

### AutoScalar <a name="kong-core.AutoScalar"></a>

#### Initializers <a name="kong-core.AutoScalar.Initializer"></a>

```typescript
import { AutoScalar } from 'kong-core'

new AutoScalar(scope: Construct, id: string, props: AutoScalarProps)
```

##### `scope`<sup>Required</sup> <a name="kong-core.AutoScalar.parameter.scope"></a>

- *Type:* [`@aws-cdk/core.Construct`](#@aws-cdk/core.Construct)

---

##### `id`<sup>Required</sup> <a name="kong-core.AutoScalar.parameter.id"></a>

- *Type:* `string`

---

##### `props`<sup>Required</sup> <a name="kong-core.AutoScalar.parameter.props"></a>

- *Type:* [`kong-core.AutoScalarProps`](#kong-core.AutoScalarProps)

---





### CertManager <a name="kong-core.CertManager"></a>

#### Initializers <a name="kong-core.CertManager.Initializer"></a>

```typescript
import { CertManager } from 'kong-core'

new CertManager(scope: Construct, id: string, props: CertManagerProps)
```

##### `scope`<sup>Required</sup> <a name="kong-core.CertManager.parameter.scope"></a>

- *Type:* [`@aws-cdk/core.Construct`](#@aws-cdk/core.Construct)

---

##### `id`<sup>Required</sup> <a name="kong-core.CertManager.parameter.id"></a>

- *Type:* `string`

---

##### `props`<sup>Required</sup> <a name="kong-core.CertManager.parameter.props"></a>

- *Type:* [`kong-core.CertManagerProps`](#kong-core.CertManagerProps)

---





### EksNodeHandler <a name="kong-core.EksNodeHandler"></a>

#### Initializers <a name="kong-core.EksNodeHandler.Initializer"></a>

```typescript
import { EksNodeHandler } from 'kong-core'

new EksNodeHandler(scope: Construct, id: string, props: NodeHandlerProps)
```

##### `scope`<sup>Required</sup> <a name="kong-core.EksNodeHandler.parameter.scope"></a>

- *Type:* [`@aws-cdk/core.Construct`](#@aws-cdk/core.Construct)

---

##### `id`<sup>Required</sup> <a name="kong-core.EksNodeHandler.parameter.id"></a>

- *Type:* `string`

---

##### `props`<sup>Required</sup> <a name="kong-core.EksNodeHandler.parameter.props"></a>

- *Type:* [`kong-core.NodeHandlerProps`](#kong-core.NodeHandlerProps)

---



#### Properties <a name="Properties"></a>

##### `notificationQueue`<sup>Required</sup> <a name="kong-core.EksNodeHandler.property.notificationQueue"></a>

- *Type:* [`@aws-cdk/aws-sqs.Queue`](#@aws-cdk/aws-sqs.Queue)

---

##### `serviceAccount`<sup>Required</sup> <a name="kong-core.EksNodeHandler.property.serviceAccount"></a>

- *Type:* [`@aws-cdk/aws-eks.ServiceAccount`](#@aws-cdk/aws-eks.ServiceAccount)

---


### ElastiCacheStack <a name="kong-core.ElastiCacheStack"></a>

#### Initializers <a name="kong-core.ElastiCacheStack.Initializer"></a>

```typescript
import { ElastiCacheStack } from 'kong-core'

new ElastiCacheStack(scope: Construct, id: string, props: ElastiCacheStackProps)
```

##### `scope`<sup>Required</sup> <a name="kong-core.ElastiCacheStack.parameter.scope"></a>

- *Type:* [`@aws-cdk/core.Construct`](#@aws-cdk/core.Construct)

---

##### `id`<sup>Required</sup> <a name="kong-core.ElastiCacheStack.parameter.id"></a>

- *Type:* `string`

---

##### `props`<sup>Required</sup> <a name="kong-core.ElastiCacheStack.parameter.props"></a>

- *Type:* [`kong-core.ElastiCacheStackProps`](#kong-core.ElastiCacheStackProps)

---





### MetricsServer <a name="kong-core.MetricsServer"></a>

#### Initializers <a name="kong-core.MetricsServer.Initializer"></a>

```typescript
import { MetricsServer } from 'kong-core'

new MetricsServer(scope: Construct, id: string, props: MetricsServerProps)
```

##### `scope`<sup>Required</sup> <a name="kong-core.MetricsServer.parameter.scope"></a>

- *Type:* [`@aws-cdk/core.Construct`](#@aws-cdk/core.Construct)

---

##### `id`<sup>Required</sup> <a name="kong-core.MetricsServer.parameter.id"></a>

- *Type:* `string`

---

##### `props`<sup>Required</sup> <a name="kong-core.MetricsServer.parameter.props"></a>

- *Type:* [`kong-core.MetricsServerProps`](#kong-core.MetricsServerProps)

---





### RdsStack <a name="kong-core.RdsStack"></a>

#### Initializers <a name="kong-core.RdsStack.Initializer"></a>

```typescript
import { RdsStack } from 'kong-core'

new RdsStack(scope: Construct, id: string, props: RdsProps)
```

##### `scope`<sup>Required</sup> <a name="kong-core.RdsStack.parameter.scope"></a>

- *Type:* [`@aws-cdk/core.Construct`](#@aws-cdk/core.Construct)

---

##### `id`<sup>Required</sup> <a name="kong-core.RdsStack.parameter.id"></a>

- *Type:* `string`

---

##### `props`<sup>Required</sup> <a name="kong-core.RdsStack.parameter.props"></a>

- *Type:* [`kong-core.RdsProps`](#kong-core.RdsProps)

---



#### Properties <a name="Properties"></a>

##### `kongPostgresSql`<sup>Required</sup> <a name="kong-core.RdsStack.property.kongPostgresSql"></a>

- *Type:* [`@aws-cdk/aws-rds.DatabaseInstance`](#@aws-cdk/aws-rds.DatabaseInstance)

---


### SecretsManager <a name="kong-core.SecretsManager"></a>

#### Initializers <a name="kong-core.SecretsManager.Initializer"></a>

```typescript
import { SecretsManager } from 'kong-core'

new SecretsManager(scope: Construct, id: string, props: SecretsManagerProps)
```

##### `scope`<sup>Required</sup> <a name="kong-core.SecretsManager.parameter.scope"></a>

- *Type:* [`@aws-cdk/core.Construct`](#@aws-cdk/core.Construct)

---

##### `id`<sup>Required</sup> <a name="kong-core.SecretsManager.parameter.id"></a>

- *Type:* `string`

---

##### `props`<sup>Required</sup> <a name="kong-core.SecretsManager.parameter.props"></a>

- *Type:* [`kong-core.SecretsManagerProps`](#kong-core.SecretsManagerProps)

---





### Telemetry <a name="kong-core.Telemetry"></a>

#### Initializers <a name="kong-core.Telemetry.Initializer"></a>

```typescript
import { Telemetry } from 'kong-core'

new Telemetry(scope: Construct, id: string, props: TelemetryProps)
```

##### `scope`<sup>Required</sup> <a name="kong-core.Telemetry.parameter.scope"></a>

- *Type:* [`@aws-cdk/core.Construct`](#@aws-cdk/core.Construct)

---

##### `id`<sup>Required</sup> <a name="kong-core.Telemetry.parameter.id"></a>

- *Type:* `string`

---

##### `props`<sup>Required</sup> <a name="kong-core.Telemetry.parameter.props"></a>

- *Type:* [`kong-core.TelemetryProps`](#kong-core.TelemetryProps)

---





## Structs <a name="Structs"></a>

### AutoScalarProps <a name="kong-core.AutoScalarProps"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { AutoScalarProps } from 'kong-core'

const autoScalarProps: AutoScalarProps = { ... }
```

##### `cluster`<sup>Required</sup> <a name="kong-core.AutoScalarProps.property.cluster"></a>

- *Type:* [`@aws-cdk/aws-eks.Cluster`](#@aws-cdk/aws-eks.Cluster)

---

##### `namespace`<sup>Required</sup> <a name="kong-core.AutoScalarProps.property.namespace"></a>

- *Type:* `string`

---

##### `nodegroup`<sup>Required</sup> <a name="kong-core.AutoScalarProps.property.nodegroup"></a>

- *Type:* [`@aws-cdk/aws-autoscaling.AutoScalingGroup`](#@aws-cdk/aws-autoscaling.AutoScalingGroup)

---

### CertManagerProps <a name="kong-core.CertManagerProps"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { CertManagerProps } from 'kong-core'

const certManagerProps: CertManagerProps = { ... }
```

##### `cacertname`<sup>Required</sup> <a name="kong-core.CertManagerProps.property.cacertname"></a>

- *Type:* `string`

---

##### `cluster`<sup>Required</sup> <a name="kong-core.CertManagerProps.property.cluster"></a>

- *Type:* [`@aws-cdk/aws-eks.Cluster`](#@aws-cdk/aws-eks.Cluster)

---

##### `clusterIssuerName`<sup>Required</sup> <a name="kong-core.CertManagerProps.property.clusterIssuerName"></a>

- *Type:* `string`

---

##### `dnsNames`<sup>Required</sup> <a name="kong-core.CertManagerProps.property.dnsNames"></a>

- *Type:* `string`[]

---

##### `hostedZoneName`<sup>Required</sup> <a name="kong-core.CertManagerProps.property.hostedZoneName"></a>

- *Type:* `string`

---

##### `namespace`<sup>Required</sup> <a name="kong-core.CertManagerProps.property.namespace"></a>

- *Type:* `string`

---

##### `nodegroup`<sup>Required</sup> <a name="kong-core.CertManagerProps.property.nodegroup"></a>

- *Type:* [`@aws-cdk/aws-autoscaling.AutoScalingGroup`](#@aws-cdk/aws-autoscaling.AutoScalingGroup)

---

##### `privateCaArn`<sup>Required</sup> <a name="kong-core.CertManagerProps.property.privateCaArn"></a>

- *Type:* `string`

---

### ElastiCacheStackProps <a name="kong-core.ElastiCacheStackProps"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { ElastiCacheStackProps } from 'kong-core'

const elastiCacheStackProps: ElastiCacheStackProps = { ... }
```

##### `numberofnodegroups`<sup>Required</sup> <a name="kong-core.ElastiCacheStackProps.property.numberofnodegroups"></a>

- *Type:* `number`

---

##### `vpc`<sup>Required</sup> <a name="kong-core.ElastiCacheStackProps.property.vpc"></a>

- *Type:* [`@aws-cdk/aws-ec2.IVpc`](#@aws-cdk/aws-ec2.IVpc)

---

### KongEksControlPlaneProps <a name="kong-core.KongEksControlPlaneProps"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { KongEksControlPlaneProps } from 'kong-core'

const kongEksControlPlaneProps: KongEksControlPlaneProps = { ... }
```

##### `clusterDns`<sup>Required</sup> <a name="kong-core.KongEksControlPlaneProps.property.clusterDns"></a>

- *Type:* `string`

---

##### `controlPlaneClusterProps`<sup>Required</sup> <a name="kong-core.KongEksControlPlaneProps.property.controlPlaneClusterProps"></a>

- *Type:* [`@aws-cdk/aws-eks.ClusterProps`](#@aws-cdk/aws-eks.ClusterProps)

> https://docs.aws.amazon.com/cdk/api/latest/docs/

---

##### `controlPlaneNodeProps`<sup>Required</sup> <a name="kong-core.KongEksControlPlaneProps.property.controlPlaneNodeProps"></a>

- *Type:* [`@aws-cdk/aws-eks.AutoScalingGroupCapacityOptions`](#@aws-cdk/aws-eks.AutoScalingGroupCapacityOptions)

> https://docs.aws.amazon.com/cdk/api/latest/docs/

---

##### `namespace`<sup>Required</sup> <a name="kong-core.KongEksControlPlaneProps.property.namespace"></a>

- *Type:* `string`

---

##### `rdsProps`<sup>Required</sup> <a name="kong-core.KongEksControlPlaneProps.property.rdsProps"></a>

- *Type:* [`kong-core.RdsDatabaseProps`](#kong-core.RdsDatabaseProps)

---

##### `telemetryDns`<sup>Required</sup> <a name="kong-core.KongEksControlPlaneProps.property.telemetryDns"></a>

- *Type:* `string`

---

### KongEksDataPlaneProps <a name="kong-core.KongEksDataPlaneProps"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { KongEksDataPlaneProps } from 'kong-core'

const kongEksDataPlaneProps: KongEksDataPlaneProps = { ... }
```

##### `clusterDns`<sup>Required</sup> <a name="kong-core.KongEksDataPlaneProps.property.clusterDns"></a>

- *Type:* `string`

---

##### `dataPlaneClusterProps`<sup>Required</sup> <a name="kong-core.KongEksDataPlaneProps.property.dataPlaneClusterProps"></a>

- *Type:* [`@aws-cdk/aws-eks.ClusterProps`](#@aws-cdk/aws-eks.ClusterProps)

> https://docs.aws.amazon.com/cdk/api/latest/docs/

---

##### `dataPlaneNodeProps`<sup>Required</sup> <a name="kong-core.KongEksDataPlaneProps.property.dataPlaneNodeProps"></a>

- *Type:* [`@aws-cdk/aws-eks.AutoScalingGroupCapacityOptions`](#@aws-cdk/aws-eks.AutoScalingGroupCapacityOptions)

> https://docs.aws.amazon.com/cdk/api/latest/docs/

---

##### `privateCaArn`<sup>Required</sup> <a name="kong-core.KongEksDataPlaneProps.property.privateCaArn"></a>

- *Type:* `string`

---

##### `telemetryDns`<sup>Required</sup> <a name="kong-core.KongEksDataPlaneProps.property.telemetryDns"></a>

- *Type:* `string`

---

### MetricsServerProps <a name="kong-core.MetricsServerProps"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { MetricsServerProps } from 'kong-core'

const metricsServerProps: MetricsServerProps = { ... }
```

##### `cluster`<sup>Required</sup> <a name="kong-core.MetricsServerProps.property.cluster"></a>

- *Type:* [`@aws-cdk/aws-eks.Cluster`](#@aws-cdk/aws-eks.Cluster)

---

### NodeHandlerProps <a name="kong-core.NodeHandlerProps"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { NodeHandlerProps } from 'kong-core'

const nodeHandlerProps: NodeHandlerProps = { ... }
```

##### `cluster`<sup>Required</sup> <a name="kong-core.NodeHandlerProps.property.cluster"></a>

- *Type:* [`@aws-cdk/aws-eks.Cluster`](#@aws-cdk/aws-eks.Cluster)

---

##### `nodegroup`<sup>Required</sup> <a name="kong-core.NodeHandlerProps.property.nodegroup"></a>

- *Type:* [`@aws-cdk/aws-autoscaling.AutoScalingGroup`](#@aws-cdk/aws-autoscaling.AutoScalingGroup)

---

### RdsDatabaseProps <a name="kong-core.RdsDatabaseProps"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RdsDatabaseProps } from 'kong-core'

const rdsDatabaseProps: RdsDatabaseProps = { ... }
```

##### `databasename`<sup>Required</sup> <a name="kong-core.RdsDatabaseProps.property.databasename"></a>

- *Type:* `string`

---

##### `postgresversion`<sup>Required</sup> <a name="kong-core.RdsDatabaseProps.property.postgresversion"></a>

- *Type:* [`@aws-cdk/aws-rds.PostgresEngineVersion`](#@aws-cdk/aws-rds.PostgresEngineVersion)

> https://docs.aws.amazon.com/cdk/api/latest/docs/

---

##### `username`<sup>Required</sup> <a name="kong-core.RdsDatabaseProps.property.username"></a>

- *Type:* `string`

---

### RdsProps <a name="kong-core.RdsProps"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { RdsProps } from 'kong-core'

const rdsProps: RdsProps = { ... }
```

##### `databasename`<sup>Required</sup> <a name="kong-core.RdsProps.property.databasename"></a>

- *Type:* `string`

---

##### `postgresversion`<sup>Required</sup> <a name="kong-core.RdsProps.property.postgresversion"></a>

- *Type:* [`@aws-cdk/aws-rds.PostgresEngineVersion`](#@aws-cdk/aws-rds.PostgresEngineVersion)

---

##### `username`<sup>Required</sup> <a name="kong-core.RdsProps.property.username"></a>

- *Type:* `string`

---

##### `vpc`<sup>Required</sup> <a name="kong-core.RdsProps.property.vpc"></a>

- *Type:* [`@aws-cdk/aws-ec2.IVpc`](#@aws-cdk/aws-ec2.IVpc)

---

### SecretsManagerProps <a name="kong-core.SecretsManagerProps"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { SecretsManagerProps } from 'kong-core'

const secretsManagerProps: SecretsManagerProps = { ... }
```

##### `cluster`<sup>Required</sup> <a name="kong-core.SecretsManagerProps.property.cluster"></a>

- *Type:* [`@aws-cdk/aws-eks.Cluster`](#@aws-cdk/aws-eks.Cluster)

---

##### `namespace`<sup>Required</sup> <a name="kong-core.SecretsManagerProps.property.namespace"></a>

- *Type:* `string`

---

##### `nodegroup`<sup>Required</sup> <a name="kong-core.SecretsManagerProps.property.nodegroup"></a>

- *Type:* [`@aws-cdk/aws-autoscaling.AutoScalingGroup`](#@aws-cdk/aws-autoscaling.AutoScalingGroup)

---

### TelemetryProps <a name="kong-core.TelemetryProps"></a>

#### Initializer <a name="[object Object].Initializer"></a>

```typescript
import { TelemetryProps } from 'kong-core'

const telemetryProps: TelemetryProps = { ... }
```

##### `cluster`<sup>Required</sup> <a name="kong-core.TelemetryProps.property.cluster"></a>

- *Type:* [`@aws-cdk/aws-eks.Cluster`](#@aws-cdk/aws-eks.Cluster)

---

##### `namespace`<sup>Required</sup> <a name="kong-core.TelemetryProps.property.namespace"></a>

- *Type:* `string`

---



