import * as eks from '@aws-cdk/aws-eks';
/**
 * @stability stable
 */
export interface KongEksDataPlaneProps {
    /**
     * @see https://docs.aws.amazon.com/cdk/api/latest/docs/
     * @stability stable
     * @summary Control Plane EKS Cluster properties
     * @aws-cdk_aws-eks .ClusterProps.html
     */
    readonly dataPlaneClusterProps: eks.ClusterProps;
    /**
     * @see https://docs.aws.amazon.com/cdk/api/latest/docs/
     * @stability stable
     * @summary Kong Data Plane EKS Nodes properties
     * @aws-cdk_aws-eks .AutoScalingGroupCapacityOptions.html
     */
    readonly dataPlaneNodeProps: eks.AutoScalingGroupCapacityOptions;
    /**
     * @stability stable
     */
    readonly clusterDns: String;
    /**
     * @stability stable
     */
    readonly telemetryDns: String;
    /**
     * @stability stable
     */
    readonly privateCaArn: string;
}
