import { AutoScalingGroup } from '@aws-cdk/aws-autoscaling';
import * as eks from '@aws-cdk/aws-eks';
import { Queue } from '@aws-cdk/aws-sqs';
import { Construct } from '@aws-cdk/core';
/**
 * @stability stable
 */
export interface NodeHandlerProps {
    /**
     * @stability stable
     */
    readonly cluster: eks.Cluster;
    /**
     * @stability stable
     */
    readonly nodegroup: AutoScalingGroup;
}
/**
 * @stability stable
 */
export declare class EksNodeHandler extends Construct {
    /**
     * @stability stable
     */
    notificationQueue: Queue;
    /**
     * @stability stable
     */
    serviceAccount: eks.ServiceAccount;
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, props: NodeHandlerProps);
}
