import * as ec2 from '@aws-cdk/aws-ec2';
import * as rds from '@aws-cdk/aws-rds';
import { DatabaseInstance } from '@aws-cdk/aws-rds';
import { Construct } from '@aws-cdk/core';
/**
 * @stability stable
 */
export interface RdsProps {
    /**
     * @stability stable
     */
    readonly vpc: ec2.IVpc;
    /**
     * @stability stable
     */
    readonly username: string;
    /**
     * @stability stable
     */
    readonly databasename: string;
    /**
     * @stability stable
     */
    readonly postgresversion: rds.PostgresEngineVersion;
}
/**
 * @stability stable
 */
export declare class RdsStack extends Construct {
    /**
     * @stability stable
     */
    kongPostgresSql: DatabaseInstance;
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, props: RdsProps);
}
